// BUMP, the imageboard porter
// ===========================
// -This software is designed to help out anon with imageboards

// -Filename: bumpmain.cpp
// -The main program entry-point

#include <iostream>

#include "Bump.h"

using std::cout;

// Display thread IDs to be updated
void notify_user(const Bump& board)
{
  cout << "\nUpdating these threads for " << board.site() << "/" << board.name()
       << "/:\n";
  for (const auto id : board.bumps())
    cout << id << '\n';
  cout.flush();
}

// Build a local, thread-sorted archive of an imageboard
// USAGE:  ./bump  site_name  board_name
int main(int argc, char* argv[])
{
  Bump board{argc, argv};

  if (board.has_bumps()) {
    notify_user(board);
    board.save_bump_thrds();
    cout << " Finished updating /" << board.name() << "/ archive.\n";
  }
  else
    cout << "\n Nothing to do, " << board.site() << "/" << board.name()
         << "/ archive up to date.\n";
}

// Copyright (2019)
// License (MIT) https://opensource.org/licenses/MIT
