// BUMP, the imageboard porter
// ===========================
// -This software is designed to help out anon with imageboards

// -Filename: muh_curl.h
// -This is the hackery of making libcurl simple to use from BUMP

#pragma once

#include <cstdlib>
#include <iostream>
#include <sstream>
#include <string>

#include "curl_easy.h"
#include "curl_exception.h"
#include "curl_form.h"
#include "curl_ios.h"

using std::cerr;
using std::string;
using std::stringstream;

using curl::curl_easy;
using curl::curl_ios;
using curl::curlcpp_traceback;
using curl_excptn = curl::curl_easy_exception;

namespace muh_curl {

//------------------------------------------------------------------------------

string proto{"http"};
string res_dir{"res"};
string media_dir{""};

// Assemble the complete URL from the supplied parts
auto muh_url(const string& site_nm,
             const string& board_nm,
             const string& page_nm,
             const string& pg_type)
{
  if (page_nm == "catalog")
    return proto + "://" + site_nm + "/" + board_nm + "/" + page_nm + "." +
           pg_type;
  else
    return proto + "://" + site_nm + "/" + board_nm + "/" + res_dir + "/" +
           page_nm + "." + pg_type;
}

//------------------------------------------------------------------------------

// Assemble the complete URL from the supplied parts
auto muh_file_url(const string& site_nm, const string& media_file)
{
  if (media_dir != "")
    return proto + "://" + site_nm + "/" + media_dir + "/" + media_file;
  else
    return proto + "://" + site_nm + media_file;
}

//------------------------------------------------------------------------------

// Return the json, or html, or file response to the caller
stringstream get_resp(const string& url)
{
  stringstream res;
  curl_ios<stringstream> writer(res);
  curl_easy conn(writer);

  conn.add<CURLOPT_URL>(url.data());
  conn.add<CURLOPT_FOLLOWLOCATION>(1L);

  conn.add<CURLOPT_TIMEOUT>(45L);

  try {
    conn.perform();
  }
  catch (const curl_excptn& err) {
    const auto errors{err.get_traceback()};
    std::cout << errors[0].first << ": '" << url
              << "'  curl::" << errors[0].second << "()\n";
  }

  return res;
}

//------------------------------------------------------------------------------

// TODO: create a 'get_fresp()' and pass the result using a curl binary stream.

}  // namespace muh_curl

// Copyright (2019)
// License (MIT) https://opensource.org/licenses/MIT
